More search improvements - a "Where am I?" link that does a reverse
[rails.git] / config / boot.rb
index 9a094cbc6dc9302dc151346f15aec13f76973ef3..b7af0c35c7e78314768de378587c84519ca55024 100644 (file)
@@ -3,7 +3,7 @@
 unless defined?(RAILS_ROOT)
   root_path = File.join(File.dirname(__FILE__), '..')
 
-  unless RUBY_PLATFORM =~ /mswin32/
+  unless RUBY_PLATFORM =~ /(:?mswin|mingw)/
     require 'pathname'
     root_path = Pathname.new(root_path).cleanpath(true).to_s
   end
@@ -22,23 +22,24 @@ unless defined?(Rails::Initializer)
     rails_gem_version = $1
 
     if version = defined?(RAILS_GEM_VERSION) ? RAILS_GEM_VERSION : rails_gem_version
-      rails_gem = Gem.cache.search('rails', "=#{version}").first
+      # Asking for 1.1.6 will give you 1.1.6.5206, if available -- makes it easier to use beta gems
+      rails_gem = Gem.cache.search('rails', "~>#{version}.0").sort_by { |g| g.version.version }.last
 
       if rails_gem
-        require_gem "rails", "=#{version}"
+        gem "rails", "=#{rails_gem.version.version}"
         require rails_gem.full_gem_path + '/lib/initializer'
       else
-        STDERR.puts %(Cannot find gem for Rails =#{version}:
+        STDERR.puts %(Cannot find gem for Rails ~>#{version}.0:
     Install the missing gem with 'gem install -v=#{version} rails', or
     change environment.rb to define RAILS_GEM_VERSION with your desired version.
   )
         exit 1
       end
     else
-      require_gem "rails"
+      gem "rails"
       require 'initializer'
     end
   end
 
   Rails::Initializer.run(:set_load_path)
-end
\ No newline at end of file
+end